#include <iostream>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <algorithm>
#include <vector>
#include <string>
#include <cstdlib>
#include <cstdio>
#include <cstring>
#include <cmath>
using namespace std;

#define sz(A) (int)(A).size()
#define vi vector<int>
#define ll long long
#define FOR(A,B) for(int A=0; A < (int) (B);A++)
#define pb push_back
#define all(x) x.begin() , x.end()

#define MaxC 100
#define MaxI 100
#define Branco 0
#define Azul 1
#define Vermelho 2
#define Verde 3
#define Amarelo 4

//#define VERIFICACAO
//#define DEBUG
//#define DEBUG2
//#define DEBUG_passoApasso

//compradores IDs : 1 ate n
//itens IDs : n+1 ate n+k

int n,k; //n compradores, k itens
int v[MaxC][MaxI]; //valor
int m[MaxC][MaxI]; //valor maximo
int r[MaxC][MaxI]; //preco minimo
int pmais[MaxI]; //preco p^(t+)
char cor[] = {'7', '4', '1', '2', '3', '5', '6', '8', '9'};

struct NO {
	int id;
	int c;
	int tipo;
};


//PARA DEBUG! //
int p_passado[MaxI];
int dist_passado[MaxI + MaxC + 10];
int pmais_passado[MaxI];
int u_passado[MaxI];
map<int,int> mu_passado;
vector<NO> adj_passado[MaxI + MaxC];
int WWW;
// <<<>>> //


NO no(int id,int c, int t) {
	NO novo;
	novo.id = id; 
	novo.c = c;
	novo.tipo = t;
	return novo;
}

string Tipo[] = {"A frente", "Inverso" , "Minimo", "Maximo" , "Terminal"};

//Caminhos
int dist[MaxI + MaxC + 5];
int dist2[MaxI + MaxC + 5];
NO pai[MaxI + MaxC + 5];
NO last_pai[MaxI + MaxC + 5];
int prior[MaxI + MaxC + 5];
multimap< pair<int,int> , NO> fila;
#define INF 2000000000

vector<NO> adj[MaxI + MaxC];


void salva_valores(int * u, int * p, map<int,int> mu) {
	for(int i=1;i<=n;i++) 
		u_passado[i] = u[i];
	
	for(int j=1;j<=k;j++)  {
		p_passado[j] = p[j];
		pmais_passado[j] = pmais[j];
	}

	for(int i=1; i <= n+k+5; i++) {
		dist_passado[i] = dist[i];
		adj_passado[i] = adj[i];
	}

	mu_passado = mu;
}

void leitura_entrada(FILE * ent) {
	fscanf(ent, "%d %d", &n, &k);
	FOR(i,n) FOR(j,k) fscanf(ent, "%d", &v[i+1][j+1]);
	FOR(i,n) FOR(j,k) fscanf(ent, "%d", &m[i+1][j+1]);
	FOR(i,n) FOR(j,k) fscanf(ent, "%d", &r[i+1][j+1]);
}

void cor_especial(char x) {
	if((int) x <= 10) x = cor[(int) x];
	printf("\e[1;3%cm", x);
}
void cor_normal() {
	printf("\e[0m");
}

void imprime(int x[MaxC][MaxI], int cc) {
	printf("%4c ", ' ');
	FOR(i,k) printf("%4d ", i+1);
	printf("\n");
	FOR(i,n) {
		printf("%4d ", i+1);
		cor_especial(cor[cc]);
		FOR(j,k)
			printf("%4d ", x[i+1][j+1]);
		printf("\n");
		cor_normal();
	}
	printf("\n");
}

void imprime_entrada() {
	printf("Vamos resolver o problema para %d compradores, e %d itens\n",n,k);
	printf("Matriz V :\n\n");
	imprime(v, Amarelo);
	printf("Matriz M :\n\n");
	imprime(m, Vermelho);
	printf("Matriz R :\n\n");
	imprime(r, Verde);
	printf("\n");
}

int monta_grafo(int *p, int *u, map<int ,int> mu) {
	int arcos = 0;
	int arcos2 = 0;
	for(int i=0; i<= n+k+2; i++) adj[i].clear();

	for(int i=1; i <=n; i++) for(int j=1; j<=k; j++) {
		//arco a frente
		if(r[i][j] <= p[j] && p[j] < m[i][j])
			adj[i].pb(no(n + j, u[i] + p[j] - v[i][j], 0));
		//arco inverso
		if(mu.count(i) && mu[i] == j+n)
			adj[j+n].pb(no(i, v[i][j] - u[i] - p[j], 1));
		//preco minimo
		if(u[i] + r[i][j] > v[i][j] && m[i][j] >= r[i][j]) {
			adj[i].pb(no(n+j, u[i] + r[i][j] - v[i][j], 2));
			arcos++;
		}
		//MODIFICACAO - 1!! (Para tratar a não posição geral)
		else if(m[i][j] >= r[i][j] && u[i] + r[i][j] == v[i][j] && p[j] < r[i][j]){
			adj[i].pb(no(n+j, u[i] + r[i][j] - v[i][j], 2));
			arcos2++;
		}
		//preco maximo
		if(u[i] + m[i][j] > v[i][j] && m[i][j] >= r[i][j]) {
			adj[i].pb(no(n+j, u[i] + m[i][j] - v[i][j], 3));
			arcos++;
		}
		//MODIFICACAO - 1!! (Para tratar a não posição geral)
		else if(m[i][j] >= r[i][j] && u[i] + m[i][j] == v[i][j] && mu.count(i) && mu[i] == j+n) {
			adj[i].pb(no(n+j, u[i] + m[i][j] - v[i][j], 3));
			arcos2++;
		}
	}
	//arco terminal
	for(int i=1; i <= n; i++) {
		if(u[i] > 0) {
			adj[i].pb(no(n+k+1, u[i], 4));
			arcos++;
		}
	}
	return arcos + arcos2;
}

void debuga(int * p, int * u, map<int,int> mu, int ite) {
	cor_especial(Branco);
	printf("Na iteracao %d\n\n", ite);

	printf("Precos:\n");
	cor_especial(Verde);
	for(int i=1;i <= k; i++)
		printf("Preco( %d ) = %d\n", i,p[i]);

	cor_especial(Branco);
	printf("Utilidades\n");
	cor_especial(Azul);
	for(int i=1; i<=n;i++) 
		printf("Util( %d ) = %d\n", i,u[i]);

	cor_especial(Branco);
	printf("Matches (comprador, item)\n");
	cor_especial(Amarelo);
	for(map<int,int>::iterator it = mu.begin(); it != mu.end(); it++) {
		if( (*it).first > n) break;
		printf("(%d, %d)\n", (*it).first, ((*it).second) - n);
	}
	cor_normal();
}

void debuga_grafo(int * p, int * u, map<int,int> mu) {
	cor_especial(Branco);
	printf("GRAFO (vertice : lista de arestas (vizinho, custo, tipo))\n");
	cor_especial(Vermelho);
	FOR(i,n+k+2) {
		if(adj[i].empty()) continue;
		if(i <= n) printf("Comprador %d: ", i);
		else printf("Item %d: " , i-n);
		FOR(j, sz(adj[i])) {
			int ajusta = 0;
			if(adj[i][j].id > n)
				ajusta = n;
			printf("(%d, %d, %s) ", (adj[i][j].id) - ajusta, adj[i][j].c, Tipo[adj[i][j].tipo].c_str());
		}
		printf("\n");
	}
	cor_normal();
}


int Verifica_Estabilidade(int * p,int * u,map<int,int> mu) {
	for(int i=1; i<=n; i++)
		for(int j=1; j<=k; j++) {
			int ok = 0;

			if(u[i] + p[j] >= v[i][j]) 
				ok = 1;
			if(p[j] >= m[i][j])
				ok = 1;
			if(u[i] + r[i][j] >= v[i][j]) 
				ok = 1;

			if(!ok) { 
				return 0;
			}
		}
	return 1;
}

int Verifica_Viabilidade(int * p,int * u,map<int,int> mu, int total) {

	if(total) {
		for(int i=1; i<=n; i++) 
			if(!mu.count(i)) 
				if(u[i] != 0) {
	//				printf(">>> Comprador %d não alocado com utilidade maior que zero (u_i = %d)\n", i, u[i]);
					return 0;
				}

		for(int j=1; j<=k; j++) 
			if(!mu.count(n+j))
				if(p[j] != 0) {
	//				printf(">>> Ítem %d não alocado com preço maior que zero (p_j = %d)\n", j, p[j]);
					return 0;
				}
	}

	for(int i=1; i<=n; i++) {
		for(int j=1; j<=k; j++) {
			int ok = 0;
			if(mu.count(i) && mu[i] == n+j) {
				if(!(p[j] >= r[i][j] && p[j] <= m[i][j]))
					ok = -1;
				if(u[i] + p[j] != v[i][j])
					ok -= 2;
			}
			if(ok != 0) {
	//			printf(">>> Par (%d,%d) alocado não viável\n", i, j);
	//			if(ok == -1 || ok == -3) printf(">>> p_j = %d não está no intervalo r_{i,j} , m_{i,j} (%d, %d)\n", p[j], r[i][j], m[i][j]);
	//			if(ok == -2 || ok == -3) printf(">>> u_i + p_j != v[i][j] >>> %d + %d != %d\n", u[i], p[j], v[i][j]);
	//			printf(">>> DEBUGA VALORES\n");
	//			printf(">>> comprador i = %d, item j = %d\n", i, j);
	//			printf(">>> p_j = %d , u_i = %d, r_{i,j} = %d, m_{i,j} = %d, v_{i,j} = %d \n", p[j],u[i], r[i][j], m[i][j], v[i][j]);
				return 0;
			}
		}
	}

	return 1;
}

int Verifica_invariante_A3(int * p, int * u, map<int,int> mu) {
	for(int j=1; j <= k; j++) {
		if(!mu.count(j+n) && p[j] != 0)
			return 0;
	}
	return 1;
}
void imprime_resposta(int *p, int * u, map<int,int> mu, int ite) {
	system("clear");
#ifdef DEBUG
	imprime_entrada();
#endif
	cor_especial(Branco);
	printf("\t\t\t\t << RESPOSTA >>> \n");
	cor_normal();
	cor_especial(Vermelho);
	printf(Verifica_Viabilidade(p,u,mu,1) ? "Solução Viável\n" : "Solução Não Viável\n" );
	printf(Verifica_Estabilidade(p,u,mu) ? "Solução Estável\n" : "Solução Não Estável\n" );
	cor_normal();
	debuga(p,u,mu,ite);
}



void devolve_caminho(vector<NO> * resp, NO atual) {
	if(pai[atual.id].id == -1) {
		(*resp).pb(atual);
		return;
	}
	devolve_caminho(resp, pai[atual.id]);
	(*resp).pb(atual);
}

vector<NO> encontra_caminho(map<int,int> mu,int * u) {
	vector<NO> resp;
	FOR(i, n+k+5){
		dist[i] = dist2[i] = INF;
		pai[i] = no(-1,-1,-1);
	}

	fila.clear();
	for(int i=1; i<=n;i++) {
		if(mu.count(i)) continue;
		if(u[i] <= 0) continue;
		fila.insert(pair< pair<int,int> ,NO> ( make_pair(0,i) , no(i,0,-1)));
		dist[i] = 0;
	}

	while(!fila.empty()) {
		NO aux = (*(fila.begin())).second;
		fila.erase(fila.begin());
		int v = aux.id;
		int c = aux.c;

		if(aux.tipo >= 2) {
			devolve_caminho(&resp, last_pai[aux.id]);
			resp.pb(aux);
			break;
		}

		FOR(i,sz(adj[v])) {
			int cst = c + adj[v][i].c;
			if(adj[v][i].tipo >= 2) { //fim do caminho
				int nova_prior = 100 + adj[v][i].tipo;
				if(dist2[adj[v][i].id] < cst) continue;
				if(!mu.count( adj[v][i].id)) nova_prior-=10;
				if(!mu.count( v )) nova_prior-=20;
				if(dist2[adj[v][i].id] == cst) {
					if(nova_prior >= prior[ adj[v][i].id] ) continue;
				}
				dist2[adj[v][i].id] = cst;
				last_pai[adj[v][i].id] = aux;
				//last_pai[adj[v][i].id].tipo = adj[v][i].tipo;
				prior[ adj[v][i].id ] = nova_prior;
				fila.insert(pair< pair<int,int> , NO> (make_pair(cst, nova_prior), no(adj[v][i].id,cst,adj[v][i].tipo)));
			}
			else { //arco a frente ou inverso
				if(dist[adj[v][i].id] <= cst) continue;
				pai[adj[v][i].id] = aux;
				dist[adj[v][i].id] = cst;
				fila.insert(pair< pair<int,int> , NO> (make_pair(cst, 0), no(adj[v][i].id,cst,adj[v][i].tipo)));
			}
		}
	}

	return resp;
}

void atualiza_distancias(int ini) {
	FOR(i, n+k+5) dist[i] = INF;
	dist[ini] = 0;
	multimap<int,int> f;
	f.insert(pair<int,int> (0, ini));
	while(!f.empty()) {
		ini = (*f.begin()).second; 
		f.erase(f.begin());
		FOR(i, sz(adj[ini])) {
			if(adj[ini][i].tipo >= 2) continue;
			int dd = dist[ini] + adj[ini][i].c;
			int viz = adj[ini][i].id;
			if(dist[viz] <= dd) continue;
			dist[viz] = dd;
			f.insert(pair<int,int> (dist[viz], viz));
		}
	} 
}

void atualiza_utilidades(int W, int ini, int * u){
	for(int i=1; i<=n; i++) {
		int aux = max(0 , W - dist[i]);
		u[i] -= aux;
	}
}
void atualiza_precos(int W, int ini, int * p, int item){
	for(int i=n+1; i<=n+k; i++) {
		int aux = max(0 , W - dist[i]);
		p[i-n] += aux;
		pmais[i-n] = p[i-n];
		if(i-n == item)
			p[i-n] = max(p[i-n], r[ini][i-n]);
	}
}


void atualiza_matching_arco_minimo(vector<NO> P, map<int,int> * mu){
	cor_especial(Vermelho);
	cor_normal();
	int dd = 0;
#ifdef DEBUG
	dd = 1;
#endif


	printf(dd?"Terminou em arco de preco minimo\n":"");
	//Caso 3.1 - item j_{l+1} está desalocado.
	if((*mu).count(P[sz(P)-1].id) == 0) {
		printf(dd?"CASO 3.1\n":"");
		for(int i=0; i < sz(P); i += 2) {
			if(i + 2 < sz(P)) {
				int comprador_ganha = P[i].id;
				int comprador_perde = P[i+2].id;
				int item = P[i+1].id;
				(*mu).erase((*mu).find(comprador_perde));
				(*mu)[item] = comprador_ganha;
				(*mu)[comprador_ganha] = item;
			}
			else {
				int comprador_ganha = P[i].id;
				int item = P[i+1].id;
				(*mu)[item] = comprador_ganha;
				(*mu)[comprador_ganha] = item;
			}
		}
		return;
	}
	//Caso 3.2 - item j_{l+1} está alocado e o preço reserva r[i_l][j_{l+1}] <= pmais[j_{l+1}].
	int comprador = P[sz(P)-2].id;
	int item = P[sz(P)-1].id;
	if( r[comprador][item-n] <= pmais[item-n] ) {
		printf(dd?"CASO 3.2\n":"");
		return;
	}
	printf(dd?"CASO 3.3\n":"");
	//Caso 3.3 - item j_{l+1} está alocado e o preço reserva r[i_l][j_{l+1}] > pmais[j_{l+1}].
	FOR(i, sz(P)-1) 
		if(P[i].id == P[sz(P)-1].id) { // P is not a path
			for(int j=i+1; j < sz(P); j += 2) {
				if(i + 2 < sz(P)) {
					int comprador_ganha = P[j].id;
					int item = P[j+1].id;
					(*mu)[item] = comprador_ganha;
					(*mu)[comprador_ganha] = item;
				}
				else {
					int comprador_ganha = P[j].id;
					int item = P[j+1].id;
					(*mu)[item] = comprador_ganha;
					(*mu)[comprador_ganha] = item;
				}
			}
			return;
		}
	//P is a path.
	for(int i=0; i < sz(P); i += 2) {
		if(i + 2 < sz(P)) {
			int comprador_ganha = P[i].id;
			int comprador_perde = P[i+2].id;
			int item = P[i+1].id;
			(*mu).erase((*mu).find(comprador_perde));
			(*mu)[item] = comprador_ganha;
			(*mu)[comprador_ganha] = item;
		}
		else {
			int comprador_ganha = P[i].id;
			int item = P[i+1].id;
			(*mu).erase( (*mu).find( (*mu)[item] ) );
			(*mu)[item] = comprador_ganha;
			(*mu)[comprador_ganha] = item;
		}
	}
}
void atualiza_matching_arco_maximo(vector<NO> P, map<int,int> * mu){
	cor_especial(Vermelho);
	cor_normal();
	int dd = 0;
#ifdef DEBUG
	dd = 1;
#endif
	printf(dd?"Terminou em arco de preco maximo\n":"");
	if(sz(P) == 2) return;
	if(P[sz(P)-1].id != P[sz(P)-3].id) {
		printf(dd?"CASO 2.2\n":"");
		return; // Caso 2.2
	}
	printf(dd?"CASO 2.1\n":"");
	//else j_{l} == l_{l+1}
	P.pop_back();
	for(int i=0; i + 2 < sz(P); i += 2) {
		int comprador_ganha = P[i].id;
		int comprador_perde = P[i+2].id;
		int item = P[i+1].id;
		(*mu).erase((*mu).find(comprador_perde));
		(*mu)[item] = comprador_ganha;
		(*mu)[comprador_ganha] = item;
	}

}
void atualiza_matching_arco_terminal(vector<NO> P, map<int,int> * mu){
	cor_especial(Vermelho);
	cor_normal();
	int dd = 0;
#ifdef DEBUG
	dd = 1;
#endif
	printf(dd?"Terminou em arco terminal\n":"");
	P.pop_back();
	for(int i=0; i + 2 < sz(P); i += 2) {
		int comprador_ganha = P[i].id;
		int comprador_perde = P[i+2].id;
		int item = P[i+1].id;
		(*mu).erase((*mu).find(comprador_perde));
		(*mu)[item] = comprador_ganha;
		(*mu)[comprador_ganha] = item;
	}
}

void atualiza_matching(vector<NO> P, map<int,int> * mu){
	int caso = (P.back()).tipo - 1;
	if(caso == 1)
		atualiza_matching_arco_minimo(P, mu);
	else if(caso == 2) 
		atualiza_matching_arco_maximo(P, mu);
	else if(caso == 3)
		atualiza_matching_arco_terminal(P, mu);
	else {
		printf(">>> ERRO6 - Caminho alternante não termina em um arco certo\n");
	}
}

void debuga_caminho(vector<NO> P) {
	cor_especial(Branco);
	printf("\nACHEI O CAMINHO (tam = %d) (No, Peso, Aresta usada)\n", sz(P));
	cor_especial(Azul);
	P[0].tipo = -1;
	FOR(i,sz(P)) {
		int ajusta = 0;
		if(i&1) {
			if(P[i].id <= n) {
				cor_especial(Vermelho);
				printf("ERRO1 - Caminho alternando contém dois compradores seguidos (Aperte Enter para Continuar)\n");
				getchar();
				cor_especial(Azul);
				getchar();
			}
			ajusta = n;
			printf("Item : ");
		}
		else {
			if(P[i].id > n) {
				cor_especial(Vermelho);
				printf("ERRO2 - Caminho alternando contém dois itens seguidos (Aperte Enter para Continuar)\n");
				getchar();
				cor_especial(Azul);
				getchar();
			}
			printf("Comprador : ");
		}

		if(P[i].tipo != -1)
			printf("(%d , %d, %s)\n", P[i].id-ajusta, P[i].c, Tipo[P[i].tipo].c_str());
		else
			printf("(%d , %d, Vertice Inicial)\n", P[i].id-ajusta, P[i].c);
	}
	cor_normal();
}

void atualiza(int * p, int * u, map<int , int> * mu, vector<NO> P) {

#ifdef DEBUG
	debuga_caminho(P);
#endif

	int W = P[ sz(P) - 1].c;
	atualiza_distancias(P[0].id);
	
	atualiza_utilidades(W, P[0].id, u);
	int id = P[ sz(P) -1].id - n;

	if(P[ sz(P) -1].tipo != 2) id = -1;

	atualiza_precos(W, P[ sz(P) - 2].id, p, id );
	atualiza_matching(P, mu);
}

void debuga_estabilidade(int * p,int * u,map<int,int> mu) {
	int comp=-1, item=0;
	for(int i=1; i<=n; i++) {
		for(int j=1; j<=k; j++) {
			int ok = 0;
			if(u[i] + p[j] >= v[i][j]) 
				ok = 1;
			if(p[j] >= m[i][j])
				ok = 1;
			if(u[i] + r[i][j] >= v[i][j])
				ok = 1;

			if(!ok) {
				comp = i;
				item = j;
				i = n+1;
				break;
			}
		}
	}
	int i = comp, j = item;
	

	printf("par (%d,%d) não estável\n", comp, item);

	printf(">>> Arcos que saíam do comprador %d na iteração passada\n", i);
	FOR(it, sz(adj_passado[i])) {
		printf(">>> Vizinho = %d, custo = %d, tipo = %s\n", adj_passado[i][it].id - n, adj_passado[i][it].c, Tipo[adj_passado[i][it].tipo].c_str());
	}

	printf(">>> W = %d\n", WWW);
	printf(">>> d(i_0, i) = %d\n", dist_passado[i]);
	printf(">>> d(i_0, j) = %d\n", dist_passado[j]);

	printf(">>> Comprador %d não estavel, no ítem %d (não valem nehuma das equações de estabilidade)\n", i, j);

	printf(">>>>>> u + p >= v\n");
	printf(">>> Tinha  %4d +  %4d >= %d ? ", u_passado[i], p_passado[j], v[i][j]);
	printf(u_passado[i] + p_passado[j] >= v[i][j]? "Sim\n" : "Nao\n");
	printf(">>> Tenho  %4d +  %4d >= %d ? ", u[i], p[j], v[i][j]);
	printf(u[i] + p[j] >= v[i][j]? "Sim\n" : "Nao\n");
	printf("\n");
	printf(">>>>>>p >= m\n");
	printf(">>> Tinha %4d >= %4d ? ", p_passado[j], m[i][j]);
	printf(p_passado[j] >= m[i][j] ? "Sim\n" : "Nao\n");
	printf(">>> Tenho %4d >= %4d ? ", p[j], m[i][j]);
	printf(p[j] >= m[i][j] ? "Sim\n" : "Nao\n");
	printf("\n");
	printf(">>>>>> u + r >= v\n");
	printf(">>> Tinha  %4d +  %4d = %d >= %d ? ", u_passado[i], r[i][j], u_passado[i] + r[i][j]  ,v[i][j]);
	printf(u_passado[i] + r[i][j] >= v[i][j] ? "Sim\n" : "Nao\n");
	printf(">>> Tenho  %4d +  %4d = %d >= %d ? ", u[i], r[i][j], u[i] + r[i][j]  ,v[i][j]);
	printf(u[i] + r[i][j] >= v[i][j] ? "Sim\n" : "Nao\n");
}


void mega_verificacao_estabilidade(int *p, int *u, map<int,int> mu) {
	if(!Verifica_Estabilidade(p,u,mu)) {
		cor_especial(Vermelho);
		printf("ERRO3 - Não vale invariante (A1) (Não estável)\n");
		printf("Aperte Enter para continuar e veja os debugs\n");
		getchar();

		debuga_estabilidade(p,u,mu);

		cor_normal();
		printf("Aperte Enter para continuar\n");
		getchar();
	}
}

void debuga_viabilidade(int * p,int * u,map<int,int> mu) {

	/*
	if(total) {
		for(int i=1; i<=n; i++) 
			if(!mu.count(i)) 
				if(u[i] != 0) {
					printf(">>> Comprador %d não alocado com utilidade maior que zero (u_i = %d)\n", i, u[i]);
					return 0;
				}

		for(int j=1; j<=k; j++) 
			if(!mu.count(n+j))
				if(p[j] != 0) {
					printf(">>> Ítem %d não alocado com preço maior que zero (p_j = %d)\n", j, p[j]);
					return 0;
				}
	}
	*/

	int comp=0,item=0;

	for(int i=1; i<=n; i++) {
		for(int j=1; j<=k; j++) {
			int ok = 1;
			if(mu.count(i) && mu[i] == n+j) {
				if(!(p[j] >= r[i][j] && p[j] <= m[i][j]))
					ok = 0;
				if(u[i] + p[j] != v[i][j])
					ok = 0;
			}
			if(!ok) {
				comp = i; 
				item = j;
				break;
			}
		}
	}
	int i=comp,j=item;
	printf(">>> Par (%d,%d) alocado não viável\n", i, j);
	printf(">>> DEBUGA VALORES\n");
	printf(">>> comprador i = %d, item j = %d\n", i, j);
	printf(">>> Tenho p_j = %d , u_i = %d, r_{i,j} = %d, m_{i,j} = %d, v_{i,j} = %d \n", p[j],u[i], r[i][j], m[i][j], v[i][j]);
	printf(">>> Tinha p_j = %d , u_i = %d, r_{i,j} = %d, m_{i,j} = %d, v_{i,j} = %d \n", p_passado[j],u_passado[i], r[i][j], m[i][j], v[i][j]);
}



void mega_verificacao_viabilidade(int * p, int * u, map<int,int> mu) {
	if(!Verifica_Viabilidade(p,u,mu,0)) {
		cor_especial(Vermelho);
		printf("ERRO4 - Não vale invariante (A2) (Não viável nos pares da alocação)\n");
		printf("Aperte Enter para continuar e veja os debugs\n");
		getchar();

		debuga_viabilidade(p,u,mu);

		cor_normal();
		printf("Aperte Enter para continuar\n");
		getchar();
	}
}

void debuga_invariante_A3(int *p, int *u, map<int,int> mu) {
	int item=0;
	for(int j=1; j <= k; j++) {
		if(!mu.count(j+n) && p[j] != 0) {
			item = j;
			break;
		}
	}
	printf(">>> Item %d ficou errado com preco != 0, e não está alocado\n", item);
	printf(">>> Tinha preço %d na iteraçao passada e agora preco é %d\n", p_passado[item], p[item]);
	if(mu_passado.count(item+n)) printf(">>> Estava alocado ao comprador na iteracao passada %d\n", mu_passado[item+n]);
	else printf(">>> Nao estava alocado na iteracao passada\n");
}

void mega_verificacao_invariante_A3(int * p, int * u, map<int,int> mu) {
	if(!Verifica_invariante_A3(p,u,mu)) {
		cor_especial(Vermelho);
		printf("ERRO5 - Não vale invariante (A3) (Preço != 3 para item não alocado)\n");
		printf("Aperte Enter para continuar e veja os debugs\n");
		getchar();

		debuga_invariante_A3(p,u,mu);

		cor_normal();
		printf("Aperte Enter para continuar\n");
		getchar();
	}
}

int stable_match(int * p, int * u, map<int,int> * mu, int ite) {

	if(ite >= n*k*3 + 10) {
		printf("LOOP INFINITO??\n");
		return -ite;
	}

#ifdef DEBUG_passoApasso
	printf("APERTE ENTER PRA CONTINUAR\n");
	getchar();
 	system("clear");	
#endif

	if(!monta_grafo(p, u, *mu)) {
		printf("Acabaram os caminhos alternantes\n");
		return ite;
	}

#ifdef DEBUG
	debuga(p,u,*mu,ite);
#endif

#ifdef DEBUG2
	debuga_grafo(p,u,*mu);
#endif

	mega_verificacao_estabilidade(p,u,*mu);
	mega_verificacao_viabilidade(p,u,*mu);
	mega_verificacao_invariante_A3(p,u,*mu);

	vector<NO> P = encontra_caminho(*mu,u);
	if(sz(P) == 0) {
		printf("Todos compradores estão alocados\n");
		return ite;
	}

	WWW = P[ sz(P) - 1].c;
	salva_valores(u,p,*mu);

	atualiza(p,u,mu,P);

	return stable_match(p,u,mu,ite+1);
}

void testa_otimalidade(int * p, int * u, map<int,int> & mu) {
	for(map<int,int>::iterator it = mu.begin(); it != mu.end(); it++) {
		if(it->first > n) break;
		int comp = it->first;
		int item = it->second - n;
		printf("Alterando par %d %d\n", comp, item);
		u[comp]++;
		p[item]--;
		int ok = 0;
		if(!Verifica_Estabilidade(p,u,mu)) {
			debuga_estabilidade(p,u,mu);
			ok = 1;
		}
		if(!Verifica_Viabilidade(p,u,mu,1)) {
			debuga_viabilidade(p,u,mu);
			ok  =1;
		}
		if(!ok) {
			printf("NAO ERA OTIMA\n");
			return;
		}
		u[comp]--;
		p[item]++;
	}

}

void resolve() {
	int p[MaxI], u[MaxC];
	memset(p,0,sizeof(p));
	int B = 0;
	FOR(i,n) FOR(j,k) B = max(B, v[i+1][j+1]+1);
	FOR(i,n+1)  
		u[i] = B;
	map<int, int> mu;
	mu.clear();
	int it = stable_match(p, u, &mu, 0);
	imprime_resposta(p, u, mu, it);

#ifdef VERIFICACAO    
	testa_otimalidade(p, u, mu);
#endif
}

int main(int argc, char *argv[]) {
	if(argc == 1) {
		printf("Faltou dizer o arquivo de entrada. (Rode \"./a.out entradaX\")\n");
		return 1;
	}
	FILE * ent = fopen(argv[1], "r");
	if(ent == NULL) {
		printf("Arquivo não existente %s\n", argv[1]);
		return 1;
	}
	leitura_entrada(ent);
#ifdef DEBUG2
	imprime_entrada();
#endif
	resolve();
	return 0;
}

